
////////////////////////////////////////////////////
void update_menu(){
	if ( (current_menu >= m_App_Interv) && (current_menu < m_App_Catcher) )	{
		update_menu_Intervalometer();
	} else {
		if ( (current_menu >= m_App_Catcher) && (current_menu < m_App_Lightning) ) {
			update_menu_Catcher();
		} else {
			if (current_menu >= m_App_Lightning) {
				update_menu_Lightning();
			}
		}
	}	
	lastButtonPushed=0;
}

void menu_Simple( char sLabel1[], char sLabel2[], byte wMenuUP, byte wMenuDOWN, byte wMenuENTER) {
	if (previous_menu != current_menu) {
		lcd.setCursor(0, 0);	lcd.print("                ");
		lcd.setCursor(0, 1);	lcd.print("                ");
		lcd.setCursor(0, 0);	lcd.print(sLabel1);
		lcd.setCursor(0, 1);	lcd.print(sLabel2);
		previous_menu=current_menu;
	}
	if (lastButtonPushed == BT_UP)   { current_menu=wMenuUP;}
	if (lastButtonPushed == BT_DOWN) { current_menu=wMenuDOWN;}
	if (lastButtonPushed == BT_ENTER){ current_menu=wMenuENTER;}
}
void menu_Toggle(boolean *v, char sLabel[], char slbl0[], char slbl1[], byte wMenuUP, byte wMenuDOWN, byte wMenuENTER) {
	if (previous_menu != current_menu) {
		lcd.setCursor(0, 0);	lcd.print("                ");
		lcd.setCursor(0, 1);	lcd.print("                ");
		lcd.setCursor(0, 0);	lcd.print(sLabel);
		lcd.setCursor(6, 1);
		if ((*v)) {
			lcd.print(slbl1);
		} else {
			lcd.print(slbl0);
		}
		previous_menu=current_menu;
	}
	if (lastButtonPushed == BT_LEFT || lastButtonPushed == BT_RIGHT){
		lcd.setCursor(0, 1);	lcd.print("                ");
		lcd.setCursor(6, 1);
		if ((*v)) {
			(*v)=false;
			lcd.print(slbl0);
		} else {
			(*v)=true;
			lcd.print(slbl1);
		}
	}
	if (lastButtonPushed == BT_UP){current_menu=wMenuUP;}
	if (lastButtonPushed == BT_DOWN) {current_menu=wMenuDOWN;}
	if (lastButtonPushed == BT_ENTER){current_menu=wMenuENTER;}
	
}

void menu_PrintParam ( int v, char sLabel[], byte wMenuUP, byte wMenuDOWN, byte wMenuENTER){
	if (previous_menu != current_menu) {
		lcd.setCursor(0, 0);	lcd.print("                ");
		lcd.setCursor(0, 0);	lcd.print(sLabel);
		lcd.setCursor(0, 1);	lcd.print("<              >");
		lcd.setCursor(6, 1);	lcd.print(v);
		previous_menu = current_menu;
	}
	if (lastButtonPushed == BT_UP){current_menu=wMenuUP;}
	if (lastButtonPushed == BT_DOWN) {current_menu=wMenuDOWN;}
	if (lastButtonPushed == BT_ENTER){current_menu=wMenuENTER;}
}
void menu_AdjustParam( int *v, iParam p, char sLabel[], byte mMenuBack){
	if (previous_menu != current_menu) {
		lcd.setCursor(0, 0);	lcd.print("                ");
		lcd.setCursor(0, 0);	lcd.print(sLabel);
		lcd.setCursor(0, 1);	lcd.print("Adj.            ");
		lcd.setCursor(6, 1);	lcd.print(*v);
		previous_menu=current_menu;
	}
	if (lastButtonPushed == BT_UP){
		*v=( (*v) + p.vStep) % p.vMax;
		lcd.setCursor(0, 1);	lcd.print("Adj.            ");
		lcd.setCursor(6, 1);	lcd.print(*v);
	}
	if (lastButtonPushed == BT_DOWN) {
		if ( (*v) - p.vStep <0){
			*v = p.vMax + (*v) - p.vStep;
		}else{
			*v = (*v) - p.vStep;
		};
		lcd.setCursor(0, 1);	lcd.print("Adj.            ");
		lcd.setCursor(6, 1);	lcd.print(*v);
	}
	if (lastButtonPushed == BT_ENTER){
		current_menu=mMenuBack;
//		SaveParameters(addTMax,TMax);
	}
}

void menu_PrintHMSMS(unsigned long t,  hmsmsParam p, char sLabel[], byte wMenuUP, byte wMenuDOWN, byte wMenuENTER) {
	
	if (previous_menu != current_menu) {
		lcd.setCursor(0, 0);	lcd.print("                ");
		lcd.setCursor(0, 1);	lcd.print("                ");
		lcd.setCursor(0, 0);	lcd.print(sLabel);
		lcd.setCursor(0, 1);
		ms2HMSMS(t,&hh,&mm,&ss,&ms);
		switch (p.format) {
			case HMSMS_HMSMS:
					lcd.print("<");
					if (hh<10) {lcd.print("0");}	// always 2 digits
					lcd.print(hh);lcd.print("h");
					if (mm<10) {lcd.print("0");}	// always 2 digits
					lcd.print(mm);lcd.print("m");
					if (ss<10) {lcd.print("0");}	// always 2 digits
					lcd.print(ss);lcd.print("s");
					if (ms<10) {lcd.print("00");} else {if (ms<100) {lcd.print("0");}}	// always 3 digits
					lcd.print(ms);lcd.print("ms>");
				break;
			case HMSMS_HMS:
					lcd.print("<   ");
					if (hh<10) {lcd.print("0");}		// always 2 digits
					lcd.print(hh);lcd.print("h");
					if (mm<10) {lcd.print("0");}	// always 2 digits
					lcd.print(mm);lcd.print("m");
					if (ss<10) {lcd.print("0");}	// always 2 digits
					lcd.print(ss);lcd.print("s  >");
				break;
			case HMSMS_SMS:
					lcd.print("<   ");
					if (ss<10) {lcd.print("0");}	// always 2 digits
					lcd.print(ss);lcd.print("s");
					if (ms<10) {lcd.print("00");} else {if (ms<100) {lcd.print("0");}}	// always 3 digits
					lcd.print(ms);lcd.print("ms   >");
				break;
		}
		previous_menu=current_menu;
	}
	if (lastButtonPushed == BT_UP)   {current_menu=wMenuUP;}
	if (lastButtonPushed == BT_DOWN) {current_menu=wMenuDOWN;}
	if (lastButtonPushed == BT_ENTER){current_menu=wMenuENTER;}
}
void menu_AdjustHMSMS(unsigned long *t,  hmsmsParam p, char sLabel1[], char sLabel2[], byte mMenuBack){
	boolean bRefresh;
	if (previous_menu != current_menu) {
		bRefresh=true;
		previous_menu=current_menu;
	}
	else {
		bRefresh=false;
	}
	switch (p.format) {
		case HMSMS_HMSMS:	LCD16x2_HMSMS_Adj(t,p,sLabel1,sLabel2, lastButtonPushed, bRefresh);	break;
		case HMSMS_HMS:		LCD16x2_HMS_Adj(t,p,sLabel1,sLabel2, lastButtonPushed, bRefresh);	break;
		case HMSMS_SMS:		LCD16x2_SMS_Adj(t,p,sLabel1,sLabel2, lastButtonPushed, bRefresh);	break;
	}

	if (lastButtonPushed == BT_ENTER){
		current_menu=mMenuBack;
//		SaveParameters(addTMax,TMax);
	}
}
