////////////////////////////////////////////////////
void update_menu_Intervalometer(){
	switch (current_menu) {
		case m_App_Interv:
			menu_Simple("DSLR TOOLBOX",">>INTERVALOMETER", m_App_Lightning, m_App_Catcher, m_App_Interv_Start);
			break;
		case m_App_Interv_Start:
			menu_Simple("INTERVALOMETER",">START MODULE", m_App_Interv_Back, m_App_Interv_Setup, m_App_Interv_Start_Run);
			break;
		case m_App_Interv_Start_Run:
			menu_App_Interv_Start_Run();
			break;
		case m_App_Interv_Setup:
			menu_Simple("INTERVALOMETER",">SETTINGS",m_App_Interv_Start,m_App_Interv_Back,m_App_Interv_Setup_PreDelay);
			break;
		case m_App_Interv_Setup_PreDelay:
			menu_PrintHMSMS(I_PreDelay,HMSParam,"PRE-DELAY DURAT.",m_App_Interv_Setup_Back,m_App_Interv_Setup_PreFocus,m_App_Interv_Setup_PreDelayAdj);
			break;
		case m_App_Interv_Setup_PreDelayAdj:
			menu_AdjustHMSMS(&I_PreDelay,HMSParam,"PRE-  >","DELAY",m_App_Interv_Setup_PreDelay);
			if (lastButtonPushed==BT_ENTER) {	EEPROM_writeAnything(I_MemAdd,I_PreDelay);	}
			break;
		case m_App_Interv_Setup_PreFocus:
			menu_PrintHMSMS(I_PreFocusDuration,SMSParam,"PRE-FOCUS DURAT.",m_App_Interv_Setup_PreDelay,m_App_Interv_Setup_ShutterDuration,m_App_Interv_Setup_PreFocusAdj);
			break;
		case m_App_Interv_Setup_PreFocusAdj:
			menu_AdjustHMSMS(&I_PreFocusDuration,SMSParam,"PRE-   >","FOCUS",m_App_Interv_Setup_PreFocus);
			if (lastButtonPushed==BT_ENTER) {EEPROM_writeAnything(I_MemAdd+4,I_PreFocusDuration);}
			break;
		case m_App_Interv_Setup_ShutterDuration:
			menu_PrintHMSMS(I_ShutterDuration,HMSMSParam,"SHUTTER DURATION",m_App_Interv_Setup_PreFocus,m_App_Interv_Setup_ShutterInterval,m_App_Interv_Setup_ShutterDurationAdj);
			break;
		case m_App_Interv_Setup_ShutterDurationAdj:
			menu_AdjustHMSMS(&I_ShutterDuration,HMSMSParam," >","",m_App_Interv_Setup_ShutterDuration);
			if (lastButtonPushed==BT_ENTER) {EEPROM_writeAnything(I_MemAdd+8,I_ShutterDuration);}
			break;
		case m_App_Interv_Setup_ShutterInterval:
			menu_PrintHMSMS(I_ShutterInterval,HMSParam,"SHUTTER INTERVAL",m_App_Interv_Setup_ShutterDuration,m_App_Interv_Setup_ShutterMax,m_App_Interv_Setup_ShutterIntervalAdj);
			break;
		case m_App_Interv_Setup_ShutterIntervalAdj:
			menu_AdjustHMSMS(&I_ShutterInterval,HMSParam,"SHUTT.>","INTER.",m_App_Interv_Setup_ShutterInterval);
			if (lastButtonPushed==BT_ENTER) {EEPROM_writeAnything(I_MemAdd+12,I_ShutterInterval);}
			break;
		case m_App_Interv_Setup_ShutterMax:
			menu_PrintParam(I_ShutterMax,"NB SHUTTER MAX.",m_App_Interv_Setup_ShutterInterval,m_App_Interv_Setup_Back,m_App_Interv_Setup_ShutterMaxAdj);
			break;
		case m_App_Interv_Setup_ShutterMaxAdj:
			menu_AdjustParam(&I_ShutterMax,I_ParamShutterMax,"NB SHUTTER MAX.",m_App_Interv_Setup_ShutterMax);
			if (lastButtonPushed==BT_ENTER) {EEPROM_writeAnything(I_MemAdd+16,I_ShutterMax);}
			break;
		case m_App_Interv_Setup_Back:
			menu_Simple("SETUP","<BACK",m_App_Interv_Setup_ShutterMax,m_App_Interv_Setup_PreDelay,m_App_Interv_Setup);
			break;
		case m_App_Interv_Back:
			menu_Simple("INTERVALOMETER","<BACK",m_App_Interv_Setup,m_App_Interv_Start,m_App_Interv);
			break;
    }
}

void menu_App_Interv_Start_Run(){
	if (previous_menu != current_menu) {
		lcd.setCursor(0, 0);
		lcd.print(">>RUNNING...    ");
		lcd.setCursor(0, 1);
		lcd.print("PHOTOS:     /   ");
		previous_menu=current_menu;
		I_App.SetParameter(I_PreDelay, I_PreFocusDuration, I_ShutterDuration, I_ShutterInterval, I_ShutterMax);
		I_App.Start();
		Photo=0;
		PhotoPrev=0;
		lcd.setCursor(9, 1);
		if (Photo<10) {lcd.print("00");} else {if (Photo<100) {lcd.print("0");}}	// always 3 digits
		lcd.print(Photo);
		lcd.setCursor(13, 1);
		if (I_ShutterMax<10) {lcd.print("00");} else {if (I_ShutterMax<100) {lcd.print("0");}}	// always 3 digits
		lcd.print(I_ShutterMax);		
		}
	if (Photo>=0 && Photo<I_ShutterMax) {
		I_App.DoIntervalometer();
		digitalWrite(ioCMD_PreFocus, I_App.IsPreFocus());
		digitalWrite(ioCMD_Shutter,  I_App.IsShutter());
		Photo = I_App.GetNbShutter();
		if (Photo != PhotoPrev) {
			PhotoPrev = Photo;
			lcd.setCursor(9, 1);
			if (Photo<10) {lcd.print("00");} else {if (Photo<100) {lcd.print("0");}}	// always 3 digits
			lcd.print(Photo);		
		}
	}
	if (Photo == I_ShutterMax & PhotoPrev==Photo) {
		PhotoPrev++;
		lcd.setCursor(0, 0);
		lcd.print(">>FINISHED!     ");
		I_App.Stop();
		digitalWrite(ioCMD_PreFocus, I_App.IsPreFocus());
		digitalWrite(ioCMD_Shutter,  I_App.IsShutter());
	}
	
	if (lastButtonPushed == BT_ENTER){
		if (Photo != I_ShutterMax) {
			I_App.Stop();
			digitalWrite(ioCMD_PreFocus, I_App.IsPreFocus());
			digitalWrite(ioCMD_Shutter,  I_App.IsShutter());
			lcd.setCursor(0, 0);
			lcd.print(">>STOPPED!      ");
		delay(1000);
		}
		current_menu=m_App_Interv_Start;
	}
}

