////////////////////////////////////////////////////
void update_menu_Lightning(){
	switch (current_menu) {
		case m_App_Lightning:
			menu_Simple("DSLR TOOLBOX",">>LIGHTNING",m_App_Catcher, m_App_Interv, m_App_Lightning_Start);
			break;
		case m_App_Lightning_Start:
			menu_Simple("LIGHTNING", ">START MODULE", m_App_Lightning_Back, m_App_Lightning_Setup, m_App_Lightning_Start_Run);
			break;
		case m_App_Lightning_Start_Run:
			menu_App_Lightning_Start_Run();
			break;
		case m_App_Lightning_Setup:
			menu_Simple("LIGHTNING",">SETTINGS",m_App_Lightning_Start,m_App_Lightning_Back,m_App_Lightning_Setup_ShutterDuration);
			break;
		case m_App_Lightning_Setup_ShutterDuration:
			menu_PrintHMSMS(L_ShutterDuration,HMSMSParam,"SHUTTER DURATION",m_App_Lightning_Setup_Back,m_App_Lightning_Setup_PostDelay,m_App_Lightning_Setup_ShutterDurationAdj);
			break;
		case m_App_Lightning_Setup_ShutterDurationAdj:
			menu_AdjustHMSMS(&L_ShutterDuration,HMSMSParam," >","",m_App_Lightning_Setup_ShutterDuration);
			if (lastButtonPushed==BT_ENTER) {EEPROM_writeAnything(L_MemAdd,		L_ShutterDuration);}
			break;
		case m_App_Lightning_Setup_PostDelay:
			menu_PrintHMSMS(L_PostDelay,HMSParam,"POST-DELAY DURA.",m_App_Lightning_Setup_ShutterDuration,m_App_Lightning_Setup_Treshold,m_App_Lightning_Setup_PostDelayAdj);
			break;
		case m_App_Lightning_Setup_PostDelayAdj:
			menu_AdjustHMSMS(&L_PostDelay,HMSParam,"POST-.>","DELAY",m_App_Lightning_Setup_PostDelay);
			if (lastButtonPushed==BT_ENTER) {EEPROM_writeAnything(L_MemAdd+4,	L_PostDelay);}
			break;
		case m_App_Lightning_Setup_Treshold:
			menu_PrintParam(L_Treshold,"TRESHOLD",m_App_Lightning_Setup_PostDelay,m_App_Lightning_Setup_Back,m_App_Lightning_Setup_TresholdAdj);
			break;
		case m_App_Lightning_Setup_TresholdAdj:
			menu_AdjustParam(&L_Treshold,L_ParamTreshold,"TRESHOLD",m_App_Lightning_Setup_Treshold);
			if (lastButtonPushed==BT_ENTER) {EEPROM_writeAnything(L_MemAdd+8,	L_Treshold);}
			break;
		case m_App_Lightning_Setup_Back:
			menu_Simple("SETUP","<BACK",m_App_Lightning_Setup_Treshold,m_App_Lightning_Setup_ShutterDuration,m_App_Lightning_Setup);
			break;
		case m_App_Lightning_Back:
			menu_Simple("LIGHTNING","<BACK",m_App_Lightning_Setup,m_App_Lightning_Start,m_App_Lightning);
			break;
    }
}

void menu_App_Lightning_Start_Run(){
	iSensor    = analogRead(aSensor1);
	if (previous_menu != current_menu) {
		lcd.setCursor(0, 0);
		lcd.print(">>RUNNING...    ");
		lcd.setCursor(0, 1);
		lcd.print("PHOTOS:         ");
		previous_menu=current_menu;
		L_App.SetParameter(L_ShutterDuration, L_PostDelay);
		L_App.Start();
		Photo=0;
		PhotoPrev=0;
		lcd.setCursor(9, 1);	lcd.print("0000");
		iSensorPrev=iSensor;
		digitalWrite(ioCMD_PreFocus, HIGH);
	}
	trigger = L_App.DoLightningDetector(iSensor-iSensorPrev,L_Treshold);
	if (trigger == HIGH) {
		digitalWrite(ioCMD_Shutter,  L_App.IsShutter());
		Photo = L_App.GetNbShutter();
		if (Photo != PhotoPrev) {
			PhotoPrev = Photo;
			lcd.setCursor(9, 1);
			if (Photo<10) {lcd.print("000");}
			else {
				if (Photo<100) {lcd.print("00");}
				else {
					if (Photo<1000) {lcd.print("0");}
					}	// always 4 digits
				}
			lcd.print(Photo);		
		}
	}
	iSensorPrev=iSensor;
	
	if (lastButtonPushed == BT_ENTER){
		L_App.Stop();
		digitalWrite(ioCMD_PreFocus, L_App.IsPreFocus());
		digitalWrite(ioCMD_Shutter,  L_App.IsShutter());
		lcd.setCursor(0, 0);
		lcd.print(">>STOPPED!      ");
		delay(2000);
		current_menu=m_App_Lightning_Start;
	}
}

