unsigned long HMSMS2ms(byte h, byte m, byte s, int ms){
	unsigned long ultemp;

	ultemp=h*3600+m*60+s;
	ultemp=ultemp*1000+ms;
	return (ultemp);
}

void ms2HMSMS(unsigned long ultms, byte *h, byte *m, byte *s, int *ms){
	unsigned long ultemp;

	*ms = int(ultms%1000);
	ultms= ultms/1000;
	*s = byte( ultms%60 );
	*m = byte( ( ultms/60)%60);
	*h = byte(ultms/3600);
}

unsigned long LCD16x2_HMSMS_Adj(unsigned long *t, hmsmsParam p, char sline1[], char sline2[], int lastBTPushed, boolean bRefresh ){
// For Crystal LCD 16x2
// boolean bRefresh : true is (current_menu != previous_menu)
// Return BT_ENTER if the button ENTER was the last pressed.
	int HMSMSposPrev=-1;

	if (bRefresh) {
		lcd.setCursor(0, 0);	lcd.print("                ");
		lcd.setCursor(0, 1);	lcd.print("                ");
		lcd.setCursor(0, 0);	lcd.print(sline1);
		lcd.setCursor(0, 1);	lcd.print(sline2);
		lcd.setCursor(2,0);
		ms2HMSMS(*t,&hh,&mm,&ss,&ms);
		if (hh<10) {lcd.print("0");}	// always 2 digits
		lcd.print(hh);lcd.print("h");
		if (mm<10) {lcd.print("0");}	// always 2 digits
		lcd.print(mm);lcd.print("m");
		if (ss<10) {lcd.print("0");}	// always 2 digits
		lcd.print(ss);lcd.print("s");
		if (ms<10) {lcd.print("00");} else {if (ms<100) {lcd.print("0");}}	// always 3 digits
		lcd.print(ms);lcd.print("ms");
//		if (p.format==HMSMS_SMS)	{HMSMSpos=HMSMS_SSPOS;}	else	{HMSMSpos=HMSMS_HHPOS;}
		HMSMSpos=HMSMS_MSPOS;
		lcd.setCursor(2+HMSMSpos*3,1);     lcd.print("--");
		if (HMSMSpos==HMSMS_MSPOS) { lcd.print("-");}
	}
	if (lastBTPushed == BT_LEFT){
		HMSMSposPrev=HMSMSpos;
		if (HMSMSpos>HMSMS_HHPOS) {HMSMSpos--;} else {HMSMSpos=HMSMS_MSPOS;}
		lcd.setCursor(2+HMSMSposPrev*3,1); lcd.print("  ");
		if (HMSMSposPrev=HMSMS_MSPOS) { lcd.print(" ");}
		lcd.setCursor(2+HMSMSpos*3,1);     lcd.print("--");
		if (HMSMSpos==HMSMS_MSPOS) { lcd.print("-");}
		}
	if (lastBTPushed == BT_RIGHT){
		HMSMSposPrev=HMSMSpos;
		if (HMSMSpos<HMSMS_MSPOS) {HMSMSpos++;} else {HMSMSpos=HMSMS_HHPOS;}
		lcd.setCursor(2+HMSMSposPrev*3,1); lcd.print("   ");
		if (HMSMSposPrev=HMSMS_MSPOS) { lcd.print(" ");}
		lcd.setCursor(2+HMSMSpos*3,1);     lcd.print("--");
		if (HMSMSpos==HMSMS_MSPOS) { lcd.print("-");}
	}
	if (lastBTPushed == BT_UP){
		switch (HMSMSpos){
			case HMSMS_HHPOS:	//0
				hh=(hh + p.hstep)%(p.hmax);
 				lcd.setCursor(2,0);
				if (hh<10) {lcd.print("0");}	// always 2 digits
				lcd.print(hh);
				break;
			case HMSMS_MMPOS:	//1
				mm=(mm+p.mstep)%(p.mmax);
				lcd.setCursor(5,0);
				if (mm<10) {lcd.print("0");}	// always 2 digits
				lcd.print(mm);
				break;
			case HMSMS_SSPOS:	//2
				ss=(ss+p.sstep)%(p.smax);
				lcd.setCursor(8,0);
				if (ss<10) {lcd.print("0");}	// always 2 digits
				lcd.print(ss);
				break;
			case HMSMS_MSPOS:	//3
				ms=(ms+p.msstep)%(p.msmax);
				lcd.setCursor(11,0);
				if (ms<10) {lcd.print("00");} else {if (ms<100) {lcd.print("0");}}	// always 3 digits
				lcd.print(ms);
				break;
		}
		*t=HMSMS2ms(hh,mm,ss,ms);
	}
	if (lastBTPushed == BT_DOWN){
		switch (HMSMSpos){
			case HMSMS_HHPOS:
				if ( hh - p.hstep < 0 ){ hh = p.hmax + hh - p.hstep; } else { hh = hh - p.hstep; };
				lcd.setCursor(2,0);
				if ( hh < 10 ) {lcd.print("0");}	// always 2 digits
				lcd.print(hh);
				break;
			case HMSMS_MMPOS:
				if ( mm - p.mstep < 0 ){ mm = p.mmax + mm - p.mstep; } else { mm = mm - p.mstep; };
				lcd.setCursor(5,0);
				if ( mm < 10 ) {lcd.print("0");}	// always 2 digits
				lcd.print(mm);
				break;
			case HMSMS_SSPOS:
				if ( ss - p.sstep < 0 ){ ss = p.smax + ss - p.sstep; } else { ss = ss - p.sstep;};
				lcd.setCursor(8,0);
				if ( ss < 10 ) {lcd.print("0");}	// always 2 digits
				lcd.print(ss);
				break;
			case HMSMS_MSPOS:
				if ( ms - p.msstep < 0){ ms = p.msmax + ms - p.msstep;}else{ ms = ms - p.msstep;};
				lcd.setCursor(11,0);
				if ( ms < 10 ) {lcd.print("00");} else {if ( ms < 100 ) {lcd.print("0");}}	// always 3 digits
				lcd.print(ms);
				break;
		}
		*t=HMSMS2ms(hh,mm,ss,ms);
	}
}
void LCD16x2_HMS_Adj(unsigned long *t, hmsmsParam p, char sline1[], char sline2[], int lastBTPushed, boolean bRefresh ){
// For Crystal LCD 16x2
// boolean bRefresh : true is (current_menu != previous_menu)
// Return BT_ENTER if the button ENTER was the last pressed.
	int HMSMSposPrev=-1;

	if (bRefresh) {
		lcd.setCursor(0, 0);	lcd.print("                ");
		lcd.setCursor(0, 1);	lcd.print("                ");
		lcd.setCursor(0,0);		lcd.print(sline1);
		lcd.setCursor(0,1);		lcd.print(sline2);
		lcd.setCursor(7,0);
		ms2HMSMS(*t,&hh,&mm,&ss,&ms);
		if (hh<10) {lcd.print("0");}	// always 2 digits
		lcd.print(hh);lcd.print("h");
		if (mm<10) {lcd.print("0");}	// always 2 digits
		lcd.print(mm);lcd.print("m");
		if (ss<10) {lcd.print("0");}	// always 2 digits
		lcd.print(ss);lcd.print("s");


//		if (p.format==HMSMS_SMS)	{HMSMSpos=HMSMS_SSPOS;}	else	{HMSMSpos=HMSMS_HHPOS;}
		HMSMSpos=HMSMS_SSPOS;
		lcd.setCursor(7+HMSMSpos*3,1);     lcd.print("--");

		}
	if (lastBTPushed == BT_LEFT){
		HMSMSposPrev=HMSMSpos;
		if (HMSMSpos>HMSMS_HHPOS) {HMSMSpos--;} else {HMSMSpos=HMSMS_SSPOS;}
		lcd.setCursor(7+HMSMSposPrev*3,1); lcd.print("  ");
		
		lcd.setCursor(7+HMSMSpos*3,1);     lcd.print("--");
		}
	if (lastBTPushed == BT_RIGHT){
		HMSMSposPrev=HMSMSpos;
		if (HMSMSpos<HMSMS_SSPOS) {HMSMSpos++;} else {HMSMSpos=HMSMS_HHPOS;}
		lcd.setCursor(7+HMSMSposPrev*3,1); lcd.print("  ");
		
		lcd.setCursor(7+HMSMSpos*3,1);     lcd.print("--");
	}
	if (lastBTPushed == BT_UP){
		switch (HMSMSpos){
			case HMSMS_HHPOS:
				hh=(hh + p.hstep)%(p.hmax);
 				lcd.setCursor(7,0);
				if (hh<10) {lcd.print("0");}	// always 2 digits
				lcd.print(hh);
				break;
			case HMSMS_MMPOS:
				mm=(mm+p.mstep)%(p.mmax);
				lcd.setCursor(10,0);
				if (mm<10) {lcd.print("0");}	// always 2 digits
				lcd.print(mm);
				break;
			case HMSMS_SSPOS:
				ss=(ss+p.sstep)%(p.smax);
				lcd.setCursor(13,0);
				if (ss<10) {lcd.print("0");}	// always 2 digits
				lcd.print(ss);
				break;






		}
		*t=HMSMS2ms(hh,mm,ss,ms);
	}
	if (lastBTPushed == BT_DOWN){
		switch (HMSMSpos){
			case HMSMS_HHPOS:
				if ( hh - p.hstep < 0 ){ hh = p.hmax + hh - p.hstep; } else { hh = hh - p.hstep; };
				lcd.setCursor(7,0);
				if ( hh < 10 ) {lcd.print("0");}	// always 2 digits
				lcd.print(hh);
				break;
			case HMSMS_MMPOS:
				if ( mm - p.mstep < 0 ){ mm = p.mmax + mm - p.mstep; } else { mm = mm - p.mstep; };
				lcd.setCursor(10,0);
				if ( mm < 10 ) {lcd.print("0");}	// always 2 digits
				lcd.print(mm);
				break;
			case HMSMS_SSPOS:
				if ( ss - p.sstep < 0 ){ ss = p.smax + ss - p.sstep; } else { ss = ss - p.sstep;};
				lcd.setCursor(13,0);
				if ( ss < 10 ) {lcd.print("0");}	// always 2 digits
				lcd.print(ss);
				break;






				}
		*t=HMSMS2ms(hh,mm,ss,ms);
	}
}
void LCD16x2_SMS_Adj(unsigned long *t, hmsmsParam p, char sline1[], char sline2[], int lastBTPushed, boolean bRefresh ){
// For Crystal LCD 16x2
// boolean bRefresh : true is (current_menu != previous_menu)
// Return BT_ENTER if the button ENTER was the last pressed.
	int HMSMSposPrev=-1;

	if (bRefresh) {
		lcd.setCursor(0, 0);	lcd.print("                ");
		lcd.setCursor(0, 1);	lcd.print("                ");
		lcd.setCursor(0, 0);		lcd.print(sline1);
		lcd.setCursor(0, 1);		lcd.print(sline2);
		lcd.setCursor(8, 0);
		ms2HMSMS(*t,&hh,&mm,&ss,&ms);




		if (ss<10) {lcd.print("0");}	// always 2 digits
		lcd.print(ss);lcd.print("s");
		if (ms<10) {lcd.print("00");} else {if (ms<100) {lcd.print("0");}}	// always 3 digits
		lcd.print(ms);lcd.print("ms");
//		if (p.format==HMSMS_SMS)	{HMSMSpos=HMSMS_SSPOS;}	else	{HMSMSpos=HMSMS_HHPOS;}
		HMSMSpos=HMSMS_MSPOS;
		lcd.setCursor(2+HMSMSpos*3,1);     lcd.print("--");
		if (HMSMSpos==HMSMS_MSPOS) { lcd.print("-");}
	}
	if (lastBTPushed == BT_LEFT){
		HMSMSposPrev=HMSMSpos;
		if (HMSMSpos>HMSMS_SSPOS) {HMSMSpos--;} else {HMSMSpos=HMSMS_MSPOS;}
		lcd.setCursor(2+HMSMSposPrev*3,1); lcd.print("  ");
		if (HMSMSposPrev=HMSMS_MSPOS) { lcd.print(" ");}
		lcd.setCursor(2+HMSMSpos*3,1);     lcd.print("--");
		if (HMSMSpos==HMSMS_MSPOS) { lcd.print("-");}
		}
	if (lastBTPushed == BT_RIGHT){
		HMSMSposPrev=HMSMSpos;
		if (HMSMSpos<HMSMS_MSPOS) {HMSMSpos++;} else {HMSMSpos=HMSMS_SSPOS;}
		lcd.setCursor(2+HMSMSposPrev*3,1); lcd.print("   ");
		if (HMSMSposPrev=HMSMS_MSPOS) { lcd.print(" ");}
		lcd.setCursor(2+HMSMSpos*3,1);     lcd.print("--");
		if (HMSMSpos==HMSMS_MSPOS) { lcd.print("-");}
	}
	if (lastBTPushed == BT_UP){
		switch (HMSMSpos){












			case HMSMS_SSPOS:
				ss=(ss+p.sstep)%(p.smax);
				lcd.setCursor(8,0);
				if (ss<10) {lcd.print("0");}	// always 2 digits
				lcd.print(ss);
				break;
			case HMSMS_MSPOS:	//3
				ms=(ms+p.msstep)%(p.msmax);
				lcd.setCursor(11,0);
				if (ms<10) {lcd.print("00");} else {if (ms<100) {lcd.print("0");}}	// always 3 digits
				lcd.print(ms);
				break;
		}
		*t=HMSMS2ms(hh,mm,ss,ms);
	}
	if (lastBTPushed == BT_DOWN){
		switch (HMSMSpos){



		
		
		
		
		
		
		
		

			case HMSMS_SSPOS:
				if ( ss - p.sstep < 0 ){ ss = p.smax + ss - p.sstep; } else { ss = ss - p.sstep;};
				lcd.setCursor(8,0);
				if ( ss < 10 ) {lcd.print("0");}	// always 2 digits
				lcd.print(ss);
				break;
			case HMSMS_MSPOS:
				if ( ms - p.msstep < 0){ ms = p.msmax + ms - p.msstep;}else{ ms = ms - p.msstep;};
				lcd.setCursor(11,0);
				if ( ms < 10 ) {lcd.print("00");} else {if ( ms < 100 ) {lcd.print("0");}}	// always 3 digits
				lcd.print(ms);
				break;
		}
		*t=HMSMS2ms(hh,mm,ss,ms);
	}
}
