#ifndef CATCHER_H
#define CATCHER_H
 
#if defined(ARDUINO) && ARDUINO >= 100
      #include "Arduino.h"
#else
      #include "WProgram.h"
#endif
  
class  CATCHER{
public:
		CATCHER();
		CATCHER(unsigned long  prd, unsigned long pfd, unsigned long sd, unsigned long pod);
		~CATCHER();
		void Start();
		void Stop();
		void SetParameter(unsigned long  prd, unsigned long pfd, unsigned long sd, unsigned long pod);
		void GetParameter(unsigned long *prd, unsigned long *pdf, unsigned long *sd, unsigned long *pod);
		int  GetNbShutter();
		void SetMemoryAddress(word addr);
		int  GetEEPROMMemorySize();
		void SetShutterStatus(boolean s);
		void SetPreFocusStatus(boolean s);
		boolean IsPreFocus();
		boolean IsShutter();
		boolean IsTakeShot();
		boolean DoCatcher(int value,int treshold);
		
private:
											// Default| nb blocks | address
		unsigned long ulPreDelay;			//   0ms  | 04 blocks | iMemoryAddr
		unsigned long ulPreFocusDuration;	//   0ms  | 04 blocks | iMemoryAddr+4
		unsigned long ulShutterDuration;	//  50ms  | 04 blocks | iMemoryAddr+8
		unsigned long ulPostDelay;			// 500ms  | 04 blocks | iMemoryAddr+12
		unsigned long ulStartTime;
		int iNbShutter;
		word iMemoryAddr;
		boolean bTakeShot;
		boolean bShutter;
		boolean bPreFocus;
		unsigned long ntt;	// Next Tigger Time
		unsigned long tsr;	// Time Shutter Release
		
		boolean SaveParameters();
		boolean LoadParameters();
};
 
#endif
