#ifndef INTERVALOMETER_H
#define INTERVALOMETER_H
 
#if defined(ARDUINO) && ARDUINO >= 100
      #include "Arduino.h"
#else
      #include "WProgram.h"
#endif
  
class  INTERVALOMETER{
public:
		INTERVALOMETER();
		INTERVALOMETER(unsigned long  pd, unsigned long  pfd, unsigned long  sd, unsigned long  si, int  nsm);
		~INTERVALOMETER();
		void Start();
		void Stop();
		boolean SetParameter(unsigned long  pd, unsigned long  pfd, unsigned long  sd, unsigned long  si, int  nsm);
		void GetParameter(unsigned long &pd, unsigned long &pfd, unsigned long &sd, unsigned long &si, int &nsm);
		int  GetNbShutter();
		void SetMemoryBlock(word addr);
		int GetEEPROMMemorySize();
		void SetShutterStatus(boolean s);
		void SetPreFocusStatus(boolean s);
		boolean IsPreFocus();
		boolean IsShutter();
		boolean IsTakeShot();
		void DoIntervalometer();
		
private:
		unsigned long ulStartTime;
											// Default| nb blocks | address
		unsigned long ulPreDelay;			// 0ms    | 04 blocks | iMemoryAddr
		unsigned long ulPreFocusDuration;	// 0ms    | 04 blocks | iMemoryAddr+4
		unsigned long ulShutterDuration;	// 100ms  | 04 blocks | iMemoryAddr+8
		unsigned long ulShutterInterval;	// 500ms  | 04 blocks | iMemoryAddr+12
		int iNbShutterMax;					// 1      | 02 blocks | iMemoryAddr+16
		int iNbShutter;
		word iMemoryAddr;
		boolean bShutter;
		boolean bPreFocus;
		boolean bTakeShot;
		unsigned long tpfn;	// Time PreFocus n+1
		unsigned long tssn;	// Time Start Shutter n+1
		unsigned long tesn;	// Time End Shutter n+1
		
		boolean SaveParameters();
		boolean LoadParameters();
		void CheckParameters();
};
 
#endif
