#ifndef LIGHTNING_H
#define LIGHTNING_H
 
#if defined(ARDUINO) && ARDUINO >= 100
      #include "Arduino.h"
#else
      #include "WProgram.h"
#endif
  
class  LIGHTNING{
public:
		LIGHTNING();
		LIGHTNING(unsigned long  sd,  unsigned long  pod, word add);
		~LIGHTNING();
		void Start();
		void Stop();
		void SetParameter(unsigned long  sd,  unsigned long  pod);
		void GetParameter(unsigned long *sd, unsigned long  *pod);
		int  GetNbShutter();
		void SetMemoryAddress(word addr);
		int GetEEPROMMemorySize();
		void SetTakeShotStatus(boolean s);
		void SetShutterStatus(boolean s);
		void SetPreFocusStatus(boolean s);
		boolean IsTakeShot();
		boolean IsPreFocus();
		boolean IsShutter();
		boolean DoLightningDetector(int value,int treshold);
		
private:
											// Default| nb blocks | address
		unsigned long ulShutterDuration;	// 50ms   | 04 blocks | iMemoryAddr
		unsigned long ulPostDelay;			// 500ms  | 04 blocks | iMemoryAddr+4
		unsigned long ulStartTime;
		int iNbShutter;
		word iMemoryAddr;
		boolean bTakeShot;
		boolean bShutter;
		boolean bPreFocus;
		unsigned long ntt;	// Next Tigger Time
		
		boolean SaveParameters();
		boolean LoadParameters();
};
 
#endif
